searchNodes=[{"doc":"Generates the required Txbox database migration.","ref":"Mix.Tasks.Txbox.Gen.Migration.html","title":"Mix.Tasks.Txbox.Gen.Migration","type":"task"},{"doc":"Txbox is a Bitcoin transaction storage schema, based on TXT. Txbox lets you store Bitcoin transactions in your application's database with searchable and filterable semantic metadata.100% compatible with TXT, with near identical schema design and API for searching and filtering.As Txbox is built on Ecto, you query your own database rather than a containerized HTTP process.Create associations with any other data from your app's domain.Like TXT, Txbox auto-syncs with the Miner API of your choice, and caches signed responses.Unlike TXT, no web UI or HTTP API is exposed. Txbox is purely a database schema with query functions - the rest is up to you.Coming soon (™) - Seamlessly import and export from other TXT-compatible platforms.InstallationThe package can be installed by adding txbox to your list of dependencies in mix.exs.def deps do [ {:txbox, &quot;~&gt; 0.1&quot;} ] endOnce installed, run the following tasks to generate and run the required database migrations.mix txbox.gen.migration mix ecto.migrateUpdate your application's configuration, making sure Txbox knows which Repo to use.# config/config.exs config :txbox, repo: MyApp.RepoFinally, add Txbox to your application's supervision tree.children = [ {Txbox, [ # Manic miner configuration (required) miner: {:taal, headers: [{&quot;token&quot;, &quot;MYTOKEN&quot;}]}, # Maximum number of times to attempt polling the miner (default is 20) max_retries: 20, # Interval (in seconds) between each mAPI request (default is 300 - 5 minutes) retry_after: 300 ]} ] Supervisor.start_link(children, strategy: :one_for_one)UsageOnce up an running, using Txbox is simple. The Txbox modules provides three functions for creating and finding transactions: set/2, get/2, and all/2.To add a transaction to Txbox, the minimum required is to give a txid.iex&gt; Txbox.set(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot; ...&gt; }) {:ok, %Tx{}}Once a transaction is added, Txbox automatically syncs with the Miner API of your choice, updating the transaction's status until it is confirmed in a block.When a channel name is ommitted, transactions are added to the default_channel/0 (&quot;txbox&quot;), but by specifiying a channel name as the first argument, that transaction will be added to that channel. You can provide additional metadata about the transaction, as well as attach the raw transaction binary.iex&gt; Txbox.set(&quot;photos&quot;, %{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; rawtx: &lt;&lt;...&gt;&gt;, ...&gt; tags: [&quot;hubble&quot;, &quot;universe&quot;], ...&gt; meta: %{ ...&gt; title: &quot;Hubble Ultra-Deep Field&quot; ...&gt; }, ...&gt; data: %{ ...&gt; bitfs: &quot;https://x.bitfs.network/6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110.out.0.3&quot; ...&gt; } ...&gt; }) {:ok, %Tx{}}The transaction can be retrieved by the txid too.iex&gt; Txbox.get(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}As before, omitting the channel scopes the query to the default_channel/0 (&quot;txbox&quot;). Alterntively you can pass the channel name as the first argument, or use &quot;_&quot; which is the TXT syntax for global scope.iex&gt; Txbox.get(&quot;_&quot;, &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}A list of transactions can be returned using all/2. The second parameter must be a map/0 of query parameters to filter and search by.iex&gt; Txbox.all(&quot;photos&quot;, %{ ...&gt; from: 636400, ...&gt; tagged: &quot;hubble&quot;, ...&gt; limit: 5 ...&gt; }) {:ok, [%Tx{}, ...]}A full text search can be made by using the :search filter parameter.iex&gt; Txbox.all(&quot;_&quot;, %{ ...&gt; search: &quot;hubble deep field&quot; ...&gt; }) {:ok, [%Tx{}, ...]}Filtering and searchingTxbox adopts the same syntax and query modifiers used by TXT. Txbox automatically normalizes the query map, so keys can be specifiied either as atoms or strings. Here are a few examples::search - Full text search made on trasactions' tags and meta data%{search: &quot;hubble deep field&quot;}:tagged - Filter transactions by the given tag or tags%{tagged: &quot;photos&quot;} - all transactions tagged with &quot;photos&quot;%{tagged: [&quot;space&quot;, &quot;hubble&quot;]} - all transactions tagged with both &quot;space&quot; and &quot;hubble&quot;%{tagged: &quot;space, hubble&quot;} - as above, but given as a comma seperated string:from - The block height from which to filter transactions by%{from: 636400} - all transactions from and including block 636400:to - The block height to which to filter transactions by%{to: 636800} - all transactions upto and including block 636800%{from: 636400, to: 636800} - all transactions in the range 636400 to 636800:at - The block height at which to filter transactions by exactly%{at: 636500} - all transactions at block 636500%{at: &quot;null&quot;} - all transactions without a block height (unconfirmed)%{at: &quot;!null&quot;} - all transactions with any block height (confirmed):order - The attribute to sort transactions by%{order: &quot;i&quot;} - sort by block height in ascending order%{order: &quot;-i&quot;} - sort by block height in descending order%{order: &quot;created_at&quot;} - sort by insertion time in ascending order%{order: &quot;-created_at&quot;} - sort by insertion time in descending order:limit - The maximum number of transactions to return:offset - The start offset from which to return transactions (for pagination)","ref":"Txbox.html","title":"Txbox","type":"module"},{"doc":"Finds a list of transactions, scoped by the specified channel and/or filtered by the map of query options.If the channel is omitted, it defaults to default_channel/0. Alernatively, the channel can be specified as &quot;_&quot; which is the TXT syntax for the global scope.Query optionsThe accepted query options are: (keys can be atoms or strings):search - Full text search made on trasactions' tags and meta data:tagged - Filter transactions by the given tag or tags:from - The block height from which to filter transactions by:to - The block height to which to filter transactions by:at - The block height at which to filter transactions by exactly:order - The attribute to sort transactions by:limit - The maximum number of transactions to return:offset - The start offset from which to return transactions (for pagination)ExamplesFind all transactions from the specified block height in the default channel (&quot;txbox&quot;)iex&gt; Txbox.all(%{from: 636400}) {:ok, [%Tx{}, ...]}Find all transactions in the specified channel with a combination of filtersiex&gt; Txbox.all(&quot;photos&quot;, %{from: 636400, tagged: &quot;hubble&quot;, limit: 5}) {:ok, [%Tx{}, ...]}Find all transactions in any channel unfilterediex&gt; Txbox.all(&quot;_&quot;) {:ok, [%Tx{}, ...]}Make full text search against the transactions' meta data and tag names.iex&gt; Txbox.all(%{search: &quot;hubble deep field&quot;}) {:ok, [%Tx{}, ...]}","ref":"Txbox.html#all/2","title":"Txbox.all/2","type":"function"},{"doc":"Returns the default channel (&quot;txbox&quot;).","ref":"Txbox.html#default_channel/0","title":"Txbox.default_channel/0","type":"function"},{"doc":"Finds a transaction by it's txid, scoped by the specified channel.If the channel is omitted, it defaults to default_channel/0. Alernatively, the channel can be specified as &quot;_&quot; which is the TXT syntax for the global scope.ExamplesFind within the default channel (&quot;txbox&quot;)iex&gt; Txbox.get(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}Find within the specified channeliex&gt; Txbox.get(&quot;photos&quot;, &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}Find within the global scopeiex&gt; Txbox.get(&quot;_&quot;, &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) {:ok, %Tx{}}","ref":"Txbox.html#get/2","title":"Txbox.get/2","type":"function"},{"doc":"Adds the given transaction parameters into Txbox, within the specified channel.If the channel is omitted, it defaults to default_channel/0.ExamplesAdd a transaction txid within the default channel (&quot;txbox&quot;).iex&gt; Txbox.set(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot; ...&gt; }) {:ok, %Tx{}}Add a transaction with associated meta data, within a specified channel.iex&gt; Txbox.set(&quot;photos&quot;, %{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; tags: [&quot;hubble&quot;, &quot;universe&quot;], ...&gt; meta: %{ ...&gt; title: &quot;Hubble Ultra-Deep Field&quot; ...&gt; }, ...&gt; data: %{ ...&gt; bitfs: &quot;https://x.bitfs.network/6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110.out.0.3&quot; ...&gt; } ...&gt; }) {:ok, %Tx{}}","ref":"Txbox.html#set/2","title":"Txbox.set/2","type":"function"},{"doc":"Starts the Txbox process linked to the current process.","ref":"Txbox.html#start_link/1","title":"Txbox.start_link/1","type":"function"},{"doc":"Collection of functions for composing Ecto queries.The functions in this module can be broadly split into two types, expressions and queries.ExpressionsExpression functions can be used to compose queries following the Elixir pipeline syntax.iex&gt; Tx ...&gt; |&gt; Transactions.confirmed(true) ...&gt; |&gt; Transactions.tagged([&quot;space&quot;, &quot;photos&quot;]) %Ecto.Query{}QueriesQuery functions interface with the repo and either create or return records from the repo.iex&gt; Transactions.list_tx() [%Tx{}, ...]","ref":"Txbox.Transactions.html","title":"Txbox.Transactions","type":"module"},{"doc":"Query by the given channel name.","ref":"Txbox.Transactions.html#channel/2","title":"Txbox.Transactions.channel/2","type":"function"},{"doc":"Query by the transaction confirmation status.","ref":"Txbox.Transactions.html#confirmed/2","title":"Txbox.Transactions.confirmed/2","type":"function"},{"doc":"Creates a transaction from the given params.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.create_tx(%{ ...&gt; txid: &quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;, ...&gt; channel: &quot;mychannel&quot; ...&gt; })","ref":"Txbox.Transactions.html#create_tx/1","title":"Txbox.Transactions.create_tx/1","type":"function"},{"doc":"Deletes the given transaction from the repo.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.get_tx(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;) ...&gt; |&gt; Transactions.delete_tx","ref":"Txbox.Transactions.html#delete_tx/1","title":"Txbox.Transactions.delete_tx/1","type":"function"},{"doc":"Get a transaction by it's internal ID or TXID.Can optionally pass a Ecto.Queryable.t as the first argument to compose queries.Examples# Find a tx by it&#39;s Txbox uuid iex&gt; tx = Transactions.find_tx &quot;e9d356cf-47e9-47c3-bfc8-c12673877302&quot; # Composed query, found by txid iex&gt; tx = Transactions.channel(&quot;mychannel) ...&gt; |&gt; Transactions.confirmed(true) ...&gt; |&gt; Transactions.find_tx(&quot;6dfccf46359e033053ab1975c1e008ddc98560f591e8ed1c8bd051050992c110&quot;)","ref":"Txbox.Transactions.html#get_tx/2","title":"Txbox.Transactions.get_tx/2","type":"function"},{"doc":"Returns a list of transactions that have not yet been confirmed by mAPI.This is used internally by Txbox.MapiStatus.Queue to fetch transactions for automatic processing.","ref":"Txbox.Transactions.html#list_pending_tx_for_mapi_check/0","title":"Txbox.Transactions.list_pending_tx_for_mapi_check/0","type":"function"},{"doc":"Returns a list of transactions.Can optionally pass a Ecto.Queryable.t as the first argument to compose queries. If a map of query options is given as a secndon argument, the query is filtered by those arguments.Examplesiex&gt; txns = Transactions.channel(&quot;mychannel) ...&gt; |&gt; Transactions.confirmed(true) ...&gt; |&gt; Transactions.list_tx","ref":"Txbox.Transactions.html#list_tx/2","title":"Txbox.Transactions.list_tx/2","type":"function"},{"doc":"Query by the given query map.","ref":"Txbox.Transactions.html#query/2","title":"Txbox.Transactions.query/2","type":"function"},{"doc":"Returns the application's configured Repo.Ensure your application's Repo is configured in config.exs:config :txbox, repo: MyApp.Repo","ref":"Txbox.Transactions.html#repo/0","title":"Txbox.Transactions.repo/0","type":"function"},{"doc":"Search by the given term.","ref":"Txbox.Transactions.html#search/2","title":"Txbox.Transactions.search/2","type":"function"},{"doc":"Returns a list of transactions filtered by the given search term.Performs a full text search on the transactions' metadata. Can optionally pass a Ecto.Queryable.t as the first argument to compose queries.Examplesiex&gt; {:ok, txns} = Transactions.search_tx(&quot;unwriter bitpic&quot;)","ref":"Txbox.Transactions.html#search_tx/2","title":"Txbox.Transactions.search_tx/2","type":"function"},{"doc":"Query by the given tag or list of tags.Optionally tags can be specified as a comma seperated string","ref":"Txbox.Transactions.html#tagged/2","title":"Txbox.Transactions.tagged/2","type":"function"},{"doc":"Updates the given transaction's status, with the specified params.Returns an :ok / :error tuple response.Examplesiex&gt; {:ok, tx} = Transactions.update_tx_status(%{ ...&gt; payload: %{...}, ...&gt; public_key: &quot;03e92d3e5c3f7bd945dfbf48e7a99393b1bfb3f11f380ae30d286e7ff2aec5a270&quot;, ...&gt; signature: &quot;3045022100a490e469426f34fcf62d0f095c10039cf5a1d535c042172786c364d41de65b3a0220654273ca42b5e955179d617ea8252e64ddf74657aa0caebda7372b40a0f07a53&quot; ...&gt; })","ref":"Txbox.Transactions.html#update_tx_status/2","title":"Txbox.Transactions.update_tx_status/2","type":"function"},{"doc":"Transaction metadata embedded schema module.The transaction metadata is a structured schema for describing human readable metadata about the transaction. The following attributes can be set::title - The title of the transaction.:description - A short description of the transaction.:image - The url of an approriate preview image for the transaction.:link - The full permalink URL to access the transaction.:content - Markdown formatted content of the transaction.","ref":"Txbox.Transactions.Meta.html","title":"Txbox.Transactions.Meta","type":"module"},{"doc":"Transaction metadata schema","ref":"Txbox.Transactions.Meta.html#t:t/0","title":"Txbox.Transactions.Meta.t/0","type":"type"},{"doc":"Miner status embedded schema module.When a new new transaction is added, Txbox automatically syncs with the configured miner's Mercant API and caches the status of the transaction. This means your transaction always has a signed payload from a miner, confirming when the transaction was mined, the block height and hash.Forr details, refer to the Manic.JSONEnvelope.payload/0.","ref":"Txbox.Transactions.Status.html","title":"Txbox.Transactions.Status","type":"module"},{"doc":"Miner status schema","ref":"Txbox.Transactions.Status.html#t:t/0","title":"Txbox.Transactions.Status.t/0","type":"type"},{"doc":"Transaction schema module.Txbox adds a single table to your database containing all of the transaction, channel and meta data.For any transaction, the only required attribute is the txid. If no channel is specified, the transaction will be added to the Txbox.default_channel/0. Optionally any of the following attributes can be set::rawtx - The raw transaction data. Must be given as a raw binary/0, not a hex encoded string.:tags - A list of tags which can be used for organising and filtering transactions.:meta - A map containing structured metadata about the transaction. See Txbox.Transactions.Meta.t/0.:data - A map containing any other arbitarry fields.When searching Txbox, the data from :tags and :meta are incorporated into full text search.Txbox automatically syncs the transaction with your configured miner, and updates the :status attribute with a cached response from the miner's Merchant API. See Txbox.Transactions.Status.t/0.","ref":"Txbox.Transactions.Tx.html","title":"Txbox.Transactions.Tx","type":"module"},{"doc":"Transaction schema","ref":"Txbox.Transactions.Tx.html#t:t/0","title":"Txbox.Transactions.Tx.t/0","type":"type"}]